<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="page_freertos_overview" kind="group">
    <compoundname>page_freertos_overview</compoundname>
    <title>FreeRTOS Overview</title>
    <detaileddescription>
<para><heading level="1">What is FreeRTOS</heading>
</para><para>FreeRTOS is a small operating system intended for use on microcontrollers. It implements a system of threads and semaphores that enable the developer to write an application that works as a set of independent threads that communicate using message queues. The FreeRTOS API Documentation is <ulink url="http://www.freertos.org/a00106.html">here</ulink>. A good place to start understanding the design is at the <ulink url="http://www.freertos.org/Creating-a-new-FreeRTOS-project.html">Creating a New FreeRTOS Project</ulink> topic in the FreeRTOS documentation.</para><para><heading level="1">How to Configure</heading>
</para><para>FreeRTOS is supplied as standard C source files that are be built along with the other C files in your project.</para><para>Every project also requires a file named FreeRTOSConfig.h. The <ulink url="http://www.freertos.org/a00110.html">Customization</ulink> documentation tells you that “FreeRTOSConfig.h tailors the RTOS kernel to the application being built. It is therefore specific to the application, not the RTOS”.</para><para>A developer modifies the macros in this file to customize the RTOS behavior to fit the application requirements. Consult the FreeRTOS documentation for details. These items are discussed here:</para><para>configCPU_CLOCK_HZ</para><para>configTOTAL_HEAP_SIZE</para><para>configHEAP_ALLOCATION_SCHEME</para><para>configMINIMAL_STACK_SIZE</para><para>configMAX_SYSCALL_INTERRUPT_PRIORITY</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;If you call a FreeRTOS API function from an interrupt with priority higher than MAX_API_CALL_INTERRUPT_PRIORITY FreeRTOS will generate an exception. Possible solutions are:&lt;ol&gt;&lt;li&gt;&lt;p&gt;Reduce all interrupt priorities to MAX_API_CALL_INTERRUPT_PRIORITY or lower&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Trig interrupt with priority less or equal MAX_API_CALL_INTERRUPT_PRIORITY and call FreeRTOS API from this interrupt handler&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Call FreeRTOS API from traceTASKSWITCHEDOUT() macro. &lt;a href="https://www.freertos.org/FreeRTOS_Support_Forum_Archive/October_2014/freertos_How_to_wake_up_a_FreeRtos_task_from_a_high_priority_ISR_140cde98j.html"&gt;see FreeRTOS support&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;/ol&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition warning"&gt;&lt;p class="admonition-title"&gt;warning&lt;/p&gt;&lt;p&gt;&lt;p&gt;If your system pipe (IPC) interrupt priority is less than or equal to MAX_API_CALL_INTERRUPT_PRIORITY then care must be taken with code that writes to flash (including the Flash/BLE/Emulated EEPROM/Bootloader SDK). The duration of critical sections must be kept short - see the &lt;a href="#group__group__flash_1group_flash_configuration"&gt;Configuration Considerations&lt;/a&gt; section of the flash driver.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><heading level="1">Clock Frequency</heading>
</para><para>FreeRTOS task scheduling and blocking is based on a tick count, which in turn is based on the clock frequency. The configCPU_CLOCK_HZ specifies the frequency. The FreeRTOSConfig.h file provided with the PDL sets this value for you as cy_delayFreqHz. This value is calculated by the system startup code.</para><para><heading level="1">FreeRTOS Memory Management</heading>
</para><para>FreeRTOS requires memory. The amount of memory required and how to manage that memory varies per application. To allow for this variation, FreeRTOS implements several different memory management schemes. These are implemented in source files named heap_1.c, heap_2.c, up through heap_5.c. Each scheme is documented in the FreeRTOS <ulink url="http://www.freertos.org/a00111.html">Memory Management</ulink> topic. These files are in the <emphasis>&lt;PDL directory&gt;/rtos/FreeRTOS/&lt;FreeRTOS version&gt;/Source/portable/MemMang</emphasis> directory.</para><para>The memory management schemes included in FreeRTOS:</para><para><itemizedlist>
<listitem><para><ulink url="http://www.freertos.org/a00111.html#heap_1">heap_1</ulink> - the very simplest, does not permit memory to be freed</para></listitem><listitem><para><ulink url="http://www.freertos.org/a00111.html#heap_2">heap_2</ulink> - permits memory to be freed, but not does coalesce adjacent free blocks.</para></listitem><listitem><para><ulink url="http://www.freertos.org/a00111.html#heap_3">heap_3</ulink> - simply wraps the standard malloc() and free() for thread safety</para></listitem><listitem><para><ulink url="http://www.freertos.org/a00111.html#heap_4">heap_4</ulink> - coalesces adjacent free blocks to avoid fragmentation. Includes absolute address placement option.</para></listitem><listitem><para><ulink url="http://www.freertos.org/a00111.html#heap_5">heap_5</ulink> - as per heap_4, with the ability to span the heap across multiple non-adjacent memory areas</para></listitem></itemizedlist>
</para><para>In the heap_3 memory scheme, your linker file specifies a heap and stack of sufficient size, and your firmware must implement and use malloc() and free() to allocate and release memory.</para><para>In the other memory schemes, the RTOS allocates a stack and heap.</para><para>For these schemes, the stack defined in the PDL linker file is used only by main() and the functions it calls. The stack can be reduced to the value needed by these functions. The FreeRTOSConfig.h definition configMINIMAL_STACK_SIZE sets the size of the stack used by the idle task. If configMINIMAL_STACK_SIZE is set too low, then the idle task will generate stack overflows.</para><para>For memory schemes other than heap_3, the project uses the configTOTAL_HEAP_SIZE definition in FreeRTOSConfig.h. In this case the heap defined in the PDL linker file can be reduced to 0, if you are not using functions like printf(). Set configTOTAL_HEAP_SIZE to the size required for the application. Your application will not link if configTOTAL_HEAP_SIZE is set too high.</para><para>For more details on Memory Management schemes see the <ulink url="http://www.freertos.org/a00111.html">FreeRTOS Documentation</ulink> page.</para><para>The parameter configHEAP_ALLOCATION_SCHEME defines memory management scheme used in the project.</para><para><heading level="1">Using FreeRTOS in a PSoC Creator project</heading>
</para><para>The FreeRTOS code example has projects for third-party IDEs. To use FreeRTOS with PSoC Creator, create a PSoC Creator project. Then click Project &gt; Build Setting &gt; Peripheral Driver Library, here you may choose the PDL software packages. To add FreeRTOS source files to your project, enable it as it is shown in the screenshot below: <image name="FreeRTOS_build_settings.png" type="html">Figure 1. Build Settings dialog in PSoC Creator</image>
 After selecting FreeRTOS in the PDL software package list, click OK. PSoC Creator adds the FreeRTOS source files to the project the next time you generate the application. Use "#include" statements in your code to include FreeRTOS header files. PSoC Creator does not include them automatically, because there could be order dependencies in your project.</para><para>When you build your code with FreeRTOS files for the first time, the compiler will issue a build warning to remind you to enter proper configuration in the FreeRTOSConfig.h file. When you have done so, remove that warning message from the FreeRTOSConfig.h file.</para><para><image name="FreeRTOS_warning.png" type="html">Figure 2. Build warning after first build of the project with included FreeRTOS sources</image>
 <heading level="1">Using FreeRTOS in a ModusToolbox project</heading>
</para><para>Use Middleware Selector with mainapp project to add FreeRTOS to existing ModusToolbox project. Open Middleware Selector and select FreeRTOS item. After selecting FreeRTOS in the Middleware list, click OK. Middleware Selector adds the FreeRTOS source files to the project. Use "#include" statements in your code to include FreeRTOS header files.</para><para>When you build your code with FreeRTOS files for the first time, the compiler will issue a build warning to remind you to enter proper configuration in the FreeRTOSConfig.h file. When you have done so, remove that warning message from the FreeRTOSConfig.h file. </para>    </detaileddescription>
  </compounddef>
</doxygen>